/*
* QuickFox Notes by Amin E (InBasic)
* eMail: inb.cor@gmail.com
*
* Source Code License: Mozilla Public License, version 1.1
*/

/**Import a text file to current tab*/
QuickFoxNotes.importText = function (file) {
	if (!file) {
		//showing the dialog 
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = qfnServices.filepicker;
		fp.init(window, this.stringsBundle.getString('selectFileOpen'), nsIFilePicker.modeOpen);

		fp.appendFilter(this.stringsBundle.getString('txtFiles'),"*.txt");
		fp.appendFilter(this.stringsBundle.getString('allFiles'),"*.*");
		
		var res = fp.show();
		if (res != nsIFilePicker.returnOK)
			return;			
		var file = fp.file;
	}
	//Detect encoding; [http://www.devhood.com/tutorials/tutorial_details.aspx?tutorial_id=469]
	var coding = "utf-8"; //var coding = "ASCII";
	if (!qfnServices.prefs.getBoolPref("readDataForceCoding")) {
		var url = qfnServices.ioSvc.newFileURI(file); if (!url || !url.schemeIs("file")) 
			throw "Expected a file URL."; 
		var dataFile = url.QueryInterface(Components.interfaces.nsIFileURL).file; 
		var istream = Components.classes["@mozilla.org/network/file-input-stream;1"].
			createInstance(Components.interfaces.nsIFileInputStream);
		istream.init(dataFile, -1, -1, false); 
		var bstream = Components.classes["@mozilla.org/binaryinputstream;1"]
			.createInstance(Components.interfaces.nsIBinaryInputStream); 
		bstream.setInputStream(istream); 
		var bytes = bstream.readBytes(4);
		
		if (bytes.charCodeAt(0) == 239 && bytes.charCodeAt(1) == 187 && bytes.charCodeAt(2) == 191)
			coding = "utf-8";
		if (bytes.charCodeAt(0) == 255 && bytes.charCodeAt(1) == 254)
			coding = "ucs-2le";
		if (bytes.charCodeAt(0) == 254 && bytes.charCodeAt(1) == 255)
			coding = "utf-16";
		if (bytes.charCodeAt(0) == 0 && bytes.charCodeAt(1) == 0 && bytes.charCodeAt(2) == 254 && bytes.charCodeAt(3) == 255)
			coding = "ucs-4";
	}
	else
		coding = qfnServices.prefs.getCharPref("readDataCoding");
		
	//Reading data and inseting it at cursor point
	const PR_RDONLY = 0x1;  // see prio.h
	
	var stream = Components.classes["@mozilla.org/network/file-input-stream;1"].
		createInstance(Components.interfaces.nsIFileInputStream);
	stream.init(file, PR_RDONLY, 0, 0);	
	
	var data = "";
	var is = Components.classes["@mozilla.org/intl/converter-input-stream;1"]
					   .createInstance(Components.interfaces.nsIConverterInputStream);
	// This assumes that fis is the nsIInputStream you want to read from
	is.init(stream, coding, 1024, 0xFFFD);
	is.QueryInterface(Components.interfaces.nsIUnicharLineInputStream);

	if (is instanceof Components.interfaces.nsIUnicharLineInputStream) {
	  var line = {};
	  var cont;
	  do {
		cont = is.readLine(line);
		data += line.value + "\n";
		// Now you can do something with line.value
	  } while (cont);
	}
	is.close();
	
	this.insertTextAtCursorPoint(data);
};
/**Export data to a text file*/
QuickFoxNotes.exportText = function (all) {
	//showing the dialog 
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = qfnServices.filepicker;
	fp.init(window, this.stringsBundle.getString('selectFileSave'), nsIFilePicker.modeSave);
	
	fp.appendFilter(this.stringsBundle.getString('txtFiles'),"*.txt");
	fp.appendFilter(this.stringsBundle.getString('allFiles'),"*.*");
	
	var res = fp.show();
	if (res == nsIFilePicker.returnCancel)
		return;
	var file = fp.file;
	if (fp.filterIndex == 0 && !(/\.txt/i.test(file.path))) { //Add .txt to the end of the file in txt mode
		file.initWithPath(file.path + ".txt");
	}
	
	//Write data to a file
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].
		 createInstance(Components.interfaces.nsIFileOutputStream);

	foStream.init(file, 0x02 | 0x08 | 0x20, 0666, 0); 
	var converter = qfnServices.converter;
	converter.init(foStream, "UTF-8", 0, 0);
	
	var textToBeExport = function () {
		var temp = "";
	
		var tab = QuickFoxNotes.tabs.getElementsByTagName("panelTab");
		//Save Tabs	//Fist tab is dummy
		for (var i = 1; i < QuickFoxNotes.currentNumberOfPanels; i++) {
			temp += qfnServices.prefs.getCharPref("TitleOpenTag") + 
					QuickFoxNotes.group.read(tab[i]) +
					qfnServices.prefs.getCharPref("TitleCloseTag") + 
					String.fromCharCode(10, 13) + 
					QuickFoxNotes.getEditor(i).value + 
					String.fromCharCode(10, 13);
		}
		//Save Sandbox notes
		var menupopup = _("editor.toolbar6.menupopup");
		for (var j = 0 ; j < menupopup.childNodes.length ; j++) {
			temp += qfnServices.prefs.getCharPref("TitleOpenTag") + 
					QuickFoxNotes.group.read(menupopup.childNodes[j]) +
					qfnServices.prefs.getCharPref("TitleCloseTag") + 
					String.fromCharCode(10, 13) + 
					QuickFoxNotes.archiveGetValue(menupopup.childNodes[j]) + 
					String.fromCharCode(10, 13);
		}
		
		return temp;
	} ();

	converter.writeString(all ? textToBeExport.replace(/\n/g, String.fromCharCode(13, 10)) : 
								this.getEditor().value.replace(/\n/g, String.fromCharCode(13, 10)));
	converter.close(); // this closes foStream
};