/*
* QuickFox Notes by Amin E (InBasic)
* eMail: inb.cor@gmail.com
*
* Source Code License: Mozilla Public License, version 1.1
*/

var guiSelector = {
	initialize: function () {
		_("gui-selector-fontsize").value = qfnServices.prefs.getCharPref("FontSize") + " px";
		_("gui-selector-tabWidth").value = qfnServices.prefs.getCharPref("TabWidth") + " px";
		_("gui-selector-textcolor").color = qfnServices.prefs.getCharPref("TextColor");
		_("gui-selector-backgroundcolor").color = qfnServices.prefs.getCharPref("TabColor");
	},
	/**Changing font size of notes*/
	changeFontSize: function (positive) {
		var fontSize = parseInt(qfnServices.prefs.getCharPref("FontSize"));
		var label = _("gui-selector-fontsize");
		
		if(positive)
			fontSize += 1;
		else
			fontSize -= 1;
		if(fontSize < 6)
			fontSize = 6;

		label.value = fontSize + " px";
		qfnServices.prefs.setCharPref("FontSize", fontSize);

		for (var i = 0; i < QuickFoxNotes.currentNumberOfPanels; i++) {
			QuickFoxNotes.getEditor(i).style.fontSize = fontSize + "px";
		}

	},
	/**Changing tab's width*/
	changeTabWidth: function (positive) {
		var tabWidth = parseInt(qfnServices.prefs.getCharPref("TabWidth"));
		var label = _("gui-selector-tabWidth");
		
		if(positive)
			tabWidth += 1;
		else
			tabWidth -= 1;
		if(tabWidth < 30)
			tabWidth = 30;

		label.value = tabWidth + " px";
		qfnServices.prefs.setCharPref("TabWidth", tabWidth);

		for (var i = 0; i < QuickFoxNotes.currentNumberOfPanels; i++) {
			QuickFoxNotes.tabs.getElementsByTagName("panelTab")[i].style.minWidth = tabWidth + "px";
		}
	},
	/**Changing tab's text color*/
	changeTextColor: function (color) {
		qfnServices.prefs.setCharPref("TextColor", color);
		for (var i = 0; i < QuickFoxNotes.currentNumberOfPanels; i++) 
			QuickFoxNotes.getEditor(i).style.setProperty("color", color, "important");
	},
	/**Changing tab's background color*/
	changeBackgroundColor: function (color) {
		qfnServices.prefs.setCharPref("TabColor", color);
		QuickFoxNotes.tabpanels.style.setProperty("background-color", color, "important");
	}
}
